*-- Procedure        : lusage.prg
*-- Author           : Harold Chattaway
*-- Project          : Generic routine
*-- Created          : 06/20/94
*-- Copyright        : Lightwave Software Engineering
*-- Description      : Logs in procedure usage into table.
*-- Calling Sample   : =lusage(program())
*-- Parameters       :  
**************************************************************************
parameters tproc
private lnoldsel

lnoldsel = select()

*--- if file does not exist in home directory, create it...
if !file("susage.dbf")
   create table susage (progfile c(12), procedure c(10), callcnt n(5))
   index on progfile+procedure tag procedure

else
   if !used("susage")
      select 0
      use susage order procedure
   
   else
      select susage
   endif !used()

endif !file()

m.procedure = ""
if at("PROCEDURE",tproc) > 0
   m.procedure = substr(tproc,at(" ",tproc)+1, at(" ",tproc,2)-at(" ",tproc))
   m.progfile = substr(tproc,at(" ",tproc,2)+1)

else
   m.progfile = trim(tproc)   
endif at()   

lckey = padr(m.progfile,12)+trim(m.procedure)

*--- see if current procedure exists, if not create new record, if it does, increment count...
if !seek(lckey)
    insert into susage (progfile, procedure, callcnt) values (m.progfile, m.procedure, 1)

else
     replace callcnt with callcnt + 1
endif !seek()

select (lnoldsel)
return
